(function() {
  'use strict';

  angular
    .module('spgTpl1')
    .service('ArquivosService', ArquivosService);

  /** @ngInject */
  function ArquivosService($resource, envService, Upload, Notification) {
    var vm = this,
      env = envService.get(),
      envVars = envService.read('all'),
      configDefault = {
        post: {
          method: "POST",
          isArray: false
        },
        update: {
          method:'PUT',
          isArray: false
        }
      };

    var processosArquivosResource = $resource(envVars.apiSigep + '/processos/:processoId/arquivos/:arquivoId', {processoId: '@id', arquivoId: '@id'}, configDefault);
    var documentosArquivosResource = $resource(envVars.apiSigep + '/documentos/:documentoId/arquivos/:arquivoId', {documentoId: '@id', arquivoId: '@id'}, configDefault);
    var uploadResource = function(id, files, tipo){
      for(var prop in files){
        upload(files[prop]);
      }

      function upload(objFile){
        Upload.upload({
          url: envVars.apiSigep + '/'+tipo+'/'+id+'/arquivos',
          data: {file: objFile}
        }).then(function(){
          Notification.success('Arquivo '+objFile.name+' enviado com sucesso!');
        });
      }
    };

    return {
      upload: uploadResource,
      processos: processosArquivosResource,
      documentos: documentosArquivosResource
    };
  }

})();
