angular
  .module('spgTpl1')
  .directive('datepicker', datepicker);

function datepicker(){
  return {
    restrict: 'E',
    scope: {
      model: '=',
      formName: '@',
      locked: '=',
      previousDates: '='
    },
    controller: function($scope){
      var vm = this;

      vm.dateOptions = {
        dateDisabled: disabled,
        formatYear: 'yy',
        maxDate: new Date(2020, 5, 22),
        minDate: new Date(),
        startingDay: 1,
        showWeeks: false
      };

      function disabled(data) {
        var date = data.date,
          mode = data.mode;
        return mode === 'day' && (date.getDay() === 0 || date.getDay() === 6);
      }

      if($scope.previousDates) {
        var toggleMin = function () {
          vm.dateOptions.minDate = vm.dateOptions.minDate ? null : new Date();
        };
        toggleMin();
      }

      vm.open1 = function() {
        vm.popup1.opened = true;
      };

      vm.formats = ['dd/MM/yyyy', 'yyyy/MM/dd', 'dd.MM.yyyy', 'shortDate'];
      vm.format = vm.formats[0];
      vm.altInputFormats = ['M!/d!/yyyy'];

      vm.popup1 = {
        opened: false
      };
    },
    controllerAs: 'ctrl',
    templateUrl: 'app/system/components/datepicker/datepicker.html',
    link: function(scope, element) {
      //var unregister = scope.$watch('model', function () {
      //  if (scope.model) {
      //    scope.model = new Date(scope.model);
      //    unregister();
      //  }
      //});

      if (scope.locked) {
        element.children(1).attr('disabled', 'disabled');
      } else {
        element.children(1).attr('readonly', 'readonly');
      }
    }
  }
}
