(function() {
  'use strict';

  angular
      .module('spgTpl1')
      .directive('multiSelectCustom', multiSelectCustom);

  /** @ngInject */
  function multiSelectCustom() {
    return {
      restrict: 'E',
      scope: {
        list: '=',
        model: '=',
        label: '@',
        locked: '=isDisabled'
      },
      controller: function($scope){
        var vm = this;

        vm.multiSelectLang = {
          selectAll       : "Todos",
          selectNone      : "Nenhum",
          reset           : "Undo all",
          search          : "Type here to search...",
          nothingSelected : "Selecione"
        };

        vm.change = function(obj){
          if(obj.ticked){
            $scope.model.push(obj);
          } else {
            $scope.model = _.remove($scope.model, function(n) {
              return n.id !== obj.id;
            });
          }

          $scope.$apply($scope.model);
        };

        var _watcher = $scope.$watch(angular.bind($scope.list, function () {
          if($scope.list && $scope.model) {
            $scope.list = _.map($scope.list, function(obj1){
              angular.forEach($scope.model, function(obj2){
                if(obj1.id === obj2.id){
                  obj1.ticked = true;
                }
              });

              return obj1;
            });

            vm.inputs = $scope.list;

            _watcher();
          }
        }));

      },
      controllerAs: 'ctrl',
      templateUrl: 'app/system/components/multiSelectCustom/multiSelectCustom.html'
    };
  }
})();

(function() {
  'use strict';

  angular
      .module('spgTpl1')
      .directive('multiSelect', multiSelect);

  /** @ngInject */
  function multiSelect() {
    return {
      restrict: 'C',
      link: function(scope, element){
        element.find('button').addClass('multi-select-btn btn-block');
      }
    };
  }
})();