(function() {
  'use strict';

  angular
    .module('spgTpl1')
    .directive('pagination', pagination);

  /** @ngInject */
  function pagination() {
    return {
      restrict: 'E',
      scope: {
        pageData: '=',
        pageChanged: '='
      },
      controller: function($scope){
        var vm = this;
        vm.pageCurrentPage = 1;

        vm.pageChanged = function(){
          var currentPage = (vm.pageCurrentPage > 0) ? vm.pageCurrentPage - 1 : vm.pageCurrentPage;
          $scope.pageChanged(currentPage);
        };
      },
      controllerAs: 'ctrl',
      templateUrl: 'app/system/components/pagination/pagination.html'
    };
  }

})();
