(function() {
  'use strict';

  angular
    .module('spgTpl1')
    .directive('uibTab', uibTab);

  /** @ngInject */
  function uibTab($interval, DashboardService, $state) {
    return {
      restrict: 'C',
      link: function(scope, element, attrs){
        element.append('<span class="uib-tab-notification deactive" title="Atualizar"></span>');
        var notification = element.find('.uib-tab-notification'),
            processosInView = 0,
            documentosInView = 0;

        var _interval = $interval(function(){
          if($state.current.name !== 'home') $interval.cancel(_interval);

          get();
        }, 60000);

        function get(){

          if(attrs.heading === 'Processos') {
            if(scope.$parent.ctrl.processos !== undefined)
              processosInView = scope.$parent.ctrl.processos.length;

            DashboardService.notificacaoProcessos.query({size: 1}).$promise.then(function (processos) {
              if(processosInView){
                var num = (processos.totalElements - processosInView > 0) ? processos.totalElements - processosInView : false;

                if(num) {
                  var _totalElements = '+' + num;
                  notification.removeClass('deactive').html(_totalElements);
                }
              } else {
                processosInView = processos.totalElements;
              }
            });
          } else {

            if(scope.$parent.ctrl.documentos !== undefined)
              documentosInView = scope.$parent.ctrl.documentos.length;

            DashboardService.notificacaoDocumentos.query({size: 1}).$promise.then(function (documentos) {
              if(documentosInView){
                var num = (documentos.totalElements - documentosInView > 0) ? documentos.totalElements - documentosInView : false;

                if(num) {
                  var _totalElements = '+' + num;
                  notification.removeClass('deactive').html(_totalElements);
                }
              } else {
                documentosInView = documentos.totalElements;
              }
            });
          }
        };

        notification.on('click', function(){
          $state.reload();
        });
      }
    };
  }
})();
